<?php
/**
 * @package SecretPages
*/
/*
Plugin Name: Секретные страницы
Plugin URI: http://info-teach.ru
Description: Плагин позволяет легко закрывать страницы выбранных разделов от НеПодписчиков. Плагин работает с сервисом SmartResponder
Version: 1.0.5
Author: 
License: free
*/
if(!function_exists('add_action')) exit();

define('SECRETPAGE_PLUGIN_ASSETS_URL', plugins_url('secretpage')  . '/assets/');
define('SECRETPAGE_PLUGIN_ASSETS_ABS', dirname(__FILE__)  . '/assets/');

require_once  'secretpage.plg.class.php';

// ADMIN 
register_activation_hook( __FILE__, array('plgSecretpage','install'));
register_deactivation_hook( __FILE__, array('plgSecretpage','uninstall'));
add_action('admin_menu', 'secretpage_admin_menu');


function secretpage_admin_menu(){
    add_options_page('Секретные страницы', 'Секретные страницы', 8, 'SecretPages', 'secretpage_options_page');
}

function secretpage_options_page() 
{
	echo "<h1>Настройка плагина <i>&laquo;Секретные страницы&raquo;</i></h1>";
    if($_POST['secretpage_settings_submit']){
        _secretpage_settings_handlerform();
    }   
    _secretpage_settings_printform();
}

function _secretpage_settings_printform(){
    
    echo "
    <form name='secretpage_settings' method='post'>
    
    <table>
            <tr><td colspan='3'><h3 class='title'>Базовые настройки:</h3></td></tr>
			<tr>
				<td>Стиль плагина:</td>
				<td><select style='width:250px' name='style'>"._secretpage_get_styles()."</select></td>
				<td><i>Выберете один из стилей оформления плагина</i></td>
			</tr>
			<tr>
				<td>Секретный код:</td>
				<td><input style='width:250px' type='text' name='secret_key' value='".plgSecretpage::get('secret_key')."'/></td>
				<td><i>Задайте свой секретный код, по которому будет разблокирован раздел (латинские буквы, цифры).</i></td>
			</tr>
			<tr>
				<td>Страница отказа:</td>
				<td><input style='width:250px' type='text' name='close_url' value='".plgSecretpage::get('close_url')."'/></td>
				<td><i>Укажите URL страницы, на которую будет перенаправляен пользователь, если нажмет кнопку &laquo;Закрыть&raquo; (по умолчанию - главная)</i></td>
			</tr>
            
            <tr><td colspan='3'><h3 class='title'>Активировать на категориях:</h3></td></tr>       
			<tr>
				<td style='vertical-align: top'>Выбрать категории:</td>
				<td colspan='2'><select style='width:400px; height: 100px;'  multiple='multiple' name='categorys[]'>"._secretpage_get_categorys()."</select></td>
			</tr>            
            
            <tr><td colspan='3'><h3 class='title'>Настройки текстов:</h3></td></tr>           
			<tr>
				<td>Заголовок:</td>
				<td colspan='2'><input style='width:800px' type='text' name='title' value='".plgSecretpage::get('title')."'/></td>
			</tr>
			<tr>
				<td>Описание:</td>
				<td colspan='2'><input style='width:800px' type='text' name='description' value='".plgSecretpage::get('description')."'/></td>
			</tr>
			<tr>
				<td>Описание2:</td>
				<td colspan='2'><input style='width:800px' type='text' name='description2' value='".plgSecretpage::get('description2')."'/></td>
			</tr>     
			<tr>
				<td>Заголовок формы подписки:</td>
				<td colspan='2'><input style='width:800px' type='text' name='titleSubcribeMe' value='".plgSecretpage::get('titleSubcribeMe')."'/></td>
			</tr> 
            
            <tr><td colspan='3'><h3 class='title'>Настройки SmartResponder.ru:</h3></td></tr>     
			<tr>
				<td>API ID:</td>
				<td><input style='width:300px' type='text' name='smart_api_id' value='".plgSecretpage::get('smart_api_id')."'/></td>
				<td><i>&nbsp;</i></td>
			</tr>
			<tr>
				<td>MD5-подпись:</td>
				<td><input style='width:300px' type='text' name='smart_api_pass' value='".plgSecretpage::get('smart_api_pass')."'/></td>
				<td><i>&nbsp;</i></td>
			</tr>
 			<tr>
				<td>ID рассылки:</td>
				<td><input style='width:300px' type='text' name='smart_api_delivery_id' value='".plgSecretpage::get('smart_api_delivery_id')."'/></td>
				<td><i>&nbsp;</i></td>
			</tr> 
 			<tr>
				<td style='vertical-align: top'>Шаблон письма,<br />отправляемого при восстановлении кода:</td>
				<td><textarea style='width:300px; resize: vertical; height: 100px;' name='smart_api_recoveryTemplate'>".plgSecretpage::get('smart_api_recoveryTemplate')."</textarea></td>
				<td style='vertical-align: top'><i>Вы можете использовать любые спец.теги, используемые в шаблонах сервиса SmartResponder.</i></td>
			</tr>   
            <tr>
                <td colspan='3'>
                <p>
                    В качестве страницы подтверждения подписки (в аккаунте SmartResponder.ru) вы можете указать любую страницу сайта, добавив в адрес сигнальную переменную <strong>".plgSecretpage::get('signal_key')."</strong>. <br />Например: <i><strong>http://mysite.ru/?".plgSecretpage::get('signal_key')."</strong></i> 
                </p>
                </td></tr>                                                                                       
			<tr>
				<td colspan='3'>
                    <br />
					<input type='submit' name='secretpage_settings_submit' class='button-primary' value='Сохранить'/>
                </td>
			</tr>
	</table>
        ";
	if (function_exists ('wp_nonce_field') )
	{
		wp_nonce_field('secretpage_settings_form'); 
	}        
    echo "<input type='hidden' value='updated' /></form>";
}

function _secretpage_settings_handlerform(){
    if (function_exists('current_user_can') && !current_user_can('manage_options')) exit();
    if (function_exists ('check_admin_referer') ){
    	check_admin_referer('secretpage_settings_form');
    }   
     
    extract($_POST);
    $errors = array();
    $styles = _secretpage_get_styles(true);
    if(!in_array($style, $styles)){
        echo _secretpage_message('Передано неверное имя стиля');
        return;    
    }
    plgSecretpage::set('style', $style);
    
    $secret_key = trim($secret_key);
    $secret_key = preg_replace('/[^a-z0-9]+/','', $secret_key);
    
    plgSecretpage::set('secret_key', $secret_key);    
    
    $close_url = trim($close_url);
    if(!$close_url) $close_url = get_option('siteurl');    
    plgSecretpage::set('close_url', $close_url);
    
    plgSecretpage::set('title', $title);
    plgSecretpage::set('description', $description);
    plgSecretpage::set('description2', $description2);
    plgSecretpage::set('titleSubcribeMe', $titleSubcribeMe);
    
    plgSecretpage::set('smart_api_id', $smart_api_id);
    plgSecretpage::set('smart_api_pass', $smart_api_pass);
    plgSecretpage::set('smart_api_delivery_id', $smart_api_delivery_id);
    plgSecretpage::set('smart_api_recoveryTemplate', $smart_api_recoveryTemplate);    
    
    // categorys
    $caregorys = array();
    if($categorys){
        foreach($categorys as $_cat){
            $caregorys[] = $_cat;
        }
    }
    plgSecretpage::set('categorys',$caregorys);
    
    echo _secretpage_message('Настройки плагина обновлены', 'updated');
}

function _secretpage_get_styles($returnArray = false){
    $current = plgSecretpage::get('style');
    $styles = array();
    
    foreach(new DirectoryIterator(SECRETPAGE_PLUGIN_ASSETS_ABS . 'styles/') as $dir){
        if($dir->isDot()) continue;
        if($dir->isDir()) $styles[] = $dir->getBasename();
    }
    
    if($returnArray) return $styles;
    
    // html
    $out = '';
    if($styles){
       foreach($styles as $style){
          $selected = ($style == $current) ? 'selected=""' : '';
          $out .= "<option $selected value='$style'>$style</option>";
       }         
    }
    
    return $out;
}
function _secretpage_get_categorys($returnArray = false){
    // все категории
    $all  = get_categories(array(
        'hide_empty' => false
    ));
    foreach($all as &$cat){
        $cat = (array) $cat;
    }
    
    if($returnArray) return $all;
    
    $arr = array();
    foreach($all as $cat1){
        $arr[$cat1['cat_ID']] = $cat1;
        
    }
    $arr = _secretpage_categorys_array_to_tree($arr);
    return _secretpage_categorys_out($arr);
}

function _secretpage_categorys_out($categorys, $level = 0){
    // текущие выбранные категории
    $current = plgSecretpage::get('categorys');

    $out = ''; // select options
    foreach($categorys as $category){
        $selected = ($current && in_array($category['cat_ID'], $current)) ? 'selected=""' : '';
        $tire = str_repeat('&mdash;', $level);
        $out .= "<option data-level='$level' $selected value='$category[cat_ID]'>$tire $category[name]</option>";
        if($category['childs']){
            $nextLevel = $level + 1;
            $out .= _secretpage_categorys_out($category['childs'], $nextLevel);
        }
        else{
            
        }
    }
    return $out;
}

// построение дерева категорий
function _secretpage_categorys_array_to_tree($dataset) { 
    if(!count($dataset)) return false;
    $tree = array();
    foreach ($dataset as $id=>&$node) 
    {
       if (!$node['parent']) 
       { // root node
         $tree[$id] = &$node;
       } 
       else 
       { // sub node
         $dataset[$node['parent']]['childs'][$id] = &$node;
       }
    }
    return $tree;
}

function _secretpage_message($message, $type = 'error'){
    return '<div id="message" class="'.$type.'"><p>'.$message.'</p></div>';
}


// frn
add_action('init', array('plgSecretpage', 'wpinit'));
add_action('wp_head', array('plgSecretpage', 'head'));
add_action('wp_footer', array('plgSecretpage', 'footer'));


