<?php
class plgSecretpage{
    public static $CookieName = 'qTy78SbecReLoc1';
    private static $_optPrefix = 'secretpage_';
    
    private static $_on = false;
    
    private static $_options = array( // options default values
                            /// base
                        	'style' => 'dark', 
                        	'secret_key' => '0000',
                        	'close_url' => '',
                            /// txt
                        	'title' => 'Этот раздел доступен только для подписчиков', 
                            'description' => 'Каждому подписчику выдается специальный код доступа, с помощью которого можно получить доступ к закрытому разделу.',
                            'description2' => 'Подписка бесплатная и займет у вас не более 1 минуты',
                            'titleSubcribeMe' =>  'Введите свои данные',
                            /// categorys
                            'categorys' => '', 
                            /// SmartResponder.ru
                        	'smart_api_id' => '',
                        	'smart_api_pass' => '',
                        	'smart_api_delivery_id' => '',   
                            'smart_api_recoveryTemplate' => '[first_name],&#13;&#10;Ваш код доступа к секретному разделу {{secret_key}}',
                            /// other
                            'request_key'   => 'aQyrTcmWkcpjUpqj89QmksdfR7',
                            'signal_key'    => 'secretpagessuccesssubscribeentercode'
    );     
    
    public static function wpinit(){
       if($_COOKIE[self::$CookieName]) return;
       if(stripos($_SERVER['REQUEST_URI'], self::get('signal_key')) !== false){
          if($_COOKIE['plgSecretpageReturnPage']){
              setcookie('plgSecretpageReturnPage', 0, 1000, '/');  
              exit(header('Location: '.$_COOKIE['plgSecretpageReturnPage'].'/#enterCode'));  
          }
            
          else self::$_on = true;  
       }
       
       
       (isset($_GET[self::$_options['request_key']])) ? self::_formHandler() :  self::_registerJS();
    }    
    
    public static function head(){
       if($_COOKIE[self::$CookieName]) return;

       if(is_single()){
           $closedCategorys = plgSecretpage::get('categorys');
           if(!$closedCategorys) return;
            
           $post_id = null ;
           $post = get_post($post_id);
           
           $categorys = array(); 
           
           foreach(get_the_category($post->ID) as $cat){
              if(in_array($cat->cat_ID, $closedCategorys)){
                self::$_on = true;
                break;
              }       
           }          
       }
       
       if(!self::$_on) return;          
       echo self::_getPluginCss();        
    }
 
     public static function footer(){
        if(!self::$_on) return;
        if(!is_admin()){
            echo self::_getPluginHtml();
        }
     }
     
     public static function getPrefix(){
        return self::$_optPrefix;
     }
     
     public static function install(){
        foreach(self::$_options as $key=>$value){
            $name = self::$_optPrefix . $key;
            add_option($name, $value);
        }
     }
     
     public static function uninstall(){
        $keys = array_keys(self::$_options);
        foreach($keys as $key=>$value){
            $name = self::$_optPrefix . $key;
            delete_option($name);
        }
     }    

     /** Get option 
     */
     public static function get($name){
        
        if($name == 'categorys') return self::_getClosedCategorys($value);
        
        $name = self::$_optPrefix . $name;
        return get_option($name);
     }

     /** Set option 
     */     
     public static function set($name, $value){
        if($name == 'categorys') return self::_setClosedCategorys($value);
        
        $name = self::$_optPrefix . $name;
        update_option($name, $value);
     }
     

    private static function _registerJS(){
       wp_register_script(
            'plgSecretpage',
            SECRETPAGE_PLUGIN_ASSETS_URL . 'js.js',
            array('jquery'),
            '1.6',
            true
       ); 
       wp_enqueue_script('plgSecretpage');               
     }
     
     private static function _formHandler()  {
        if($_SERVER['HTTP_X_REQUESTED_WITH'] != 'XMLHttpRequest') return;
        
        require_once SECRETPAGE_PLUGIN_ASSETS_ABS . 'cls/cls.php';
        
        $smartresponder = new SmartResponderApi(
            self::get('smart_api_id'), 
            self::get('smart_api_pass'), 
            self::get('smart_api_delivery_id')
        );
        
        $recoveryTemplate = str_replace('&#13;&#10;', "\n", self::get('smart_api_recoveryTemplate'));
        $recoveryTemplate = str_replace('{{secret_key}}',   self::get('secret_key'), $recoveryTemplate);
        
        $handler = new SecretPageHandler($smartresponder, $_GET, self::$CookieName); 
        $handler->set('recoveryTemplate', $recoveryTemplate);
        $handler->set('secret_key', self::get('secret_key'));
        
        $handler->execute();        
     }
      

    /** 
     * @return array ids 
    */
    private static function _getClosedCategorys(){
        return explode(',',get_option(self::$_optPrefix . 'categorys'));
    }
    
    /**
     * @param  array
     * @return str
    */
    private static function _setClosedCategorys($array){
        $caregorys = implode(',', $array);
        update_option(self::$_optPrefix . 'categorys', $caregorys); 
        return $caregorys;
    }   
    
    private static function _getPluginHtml(){

        $keys = array_keys(self::$_options);
        $template = file_get_contents(SECRETPAGE_PLUGIN_ASSETS_ABS . 'template.html'); 
        
        // replace placeholders
        foreach($keys as $key){
             if(strpos($key, 'smart_api') === true) continue;
             $template = str_replace('{{'.$key.'}}', self::get($key), $template);
        }
        $template = str_replace('{{loading_img}}', SECRETPAGE_PLUGIN_ASSETS_URL . 'styles/' . self::get('style') . '/preloader.gif', $template);
        
        $template = preg_replace("/\s+/", ' ', $template);
        $template = str_replace('> <', '><', $template);
                       
        return $template;
    } 
    
    
    private static function _getPluginCss(){
       $style = self::get('style');
       $style = SECRETPAGE_PLUGIN_ASSETS_URL . 'styles/'.$style.'/css.css';
       return '<link rel="stylesheet" href="'. $style .'" />';  
    }     
}
